%global flavor gcc32

%global __strip %{_mingw32_strip}
%global __objdump %{_mingw32_objdump}
%global _use_internal_dependency_generator 0
%global __find_requires %{_mingw32_findrequires}
%global __find_provides %{_mingw32_findprovides}
%define __debug_install_post %{_mingw32_debug_install_post}

%global oname globus-rls-client
%global _name %(tr - _ <<< %{oname})

Name:		mingw32-%{oname}
Version:	5.2
Release:	5%{?dist}
Summary:	Globus Toolkit for MinGW - Replica Location Service Client

Group:		Development/Libraries
License:	ASL 2.0
URL:		http://www.globus.org/
#		Source is extracted from the globus toolkit installer:
#		wget -N http://www-unix.globus.org/ftppub/gt5/5.0/5.0.2/installers/src/gt5.0.2-all-source-installer.tar.bz2
#		tar -jxf gt5.0.2-all-source-installer.tar.bz2
#		mv gt5.0.2-all-source-installer/source-trees/replica/rls/client globus_rls_client-5.2
#		cp -p gt5.0.2-all-source-installer/source-trees/core/source/GLOBUS_LICENSE globus_rls_client-5.2
#		rm -rf globus_rls_client-5.2/java
#		tar -zcf globus_rls_client-5.2.tar.gz globus_rls_client-5.2
Source:		%{_name}-%{version}.tar.gz
#		Fix some doxygen warnings:
#		http://bugzilla.globus.org/bugzilla/show_bug.cgi?id=6740
Patch0:		%{oname}-doxygen.patch
#		Fix format errors:
#		http://bugzilla.globus.org/bugzilla/show_bug.cgi?id=6750
Patch1:		%{oname}-format.patch
#		Fixes for mingw compilation:
#		http://bugzilla.globus.org/bugzilla/show_bug.cgi?id=6742
Patch2:		%{oname}-mingw.patch
#		Depend on GT 5.2.0 library versions
Patch3:		%{oname}-deps.patch
BuildArch:	noarch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

Requires:	mingw32-globus-common
BuildRequires:	grid-packaging-tools >= 3.4
BuildRequires:	mingw32-globus-core >= 8
BuildRequires:	mingw32-globus-common >= 14
BuildRequires:	mingw32-globus-gssapi-gsi >= 10
BuildRequires:	mingw32-globus-io >= 9
BuildRequires:	mingw32-filesystem
BuildRequires:	mingw32-gcc

%description
The Globus Toolkit is an open source software toolkit used for building Grid
systems and applications. It is being developed by the Globus Alliance and
many others all over the world. A growing number of projects and companies are
using the Globus Toolkit to unlock the potential of grids for their cause.

The %{name} package contains:
Replica Location Service Client

%{?_mingw32_debug_package}

%prep
%setup -q -n %{_name}-%{version}
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1

%build
export GPT_LOCATION=%{_prefix}
export GLOBUS_LOCATION=%{_mingw32_prefix}

# Remove files that should be replaced during bootstrap
rm -f doxygen/Doxyfile*
rm -f doxygen/Makefile.am
rm -f pkgdata/Makefile.am
rm -f globus_automake*
rm -rf autom4te.cache

# Remove flavor tags
for f in `find . -name Makefile.am` ; do
  sed -e 's!^flavorinclude_HEADERS!include_HEADERS!' \
      -e 's!\(lib[a-zA-Z_]*\)_$(GLOBUS_FLAVOR_NAME)\.la!\1.la!g' \
      -e 's!^\(lib[a-zA-Z_]*\)___GLOBUS_FLAVOR_NAME__la_!\1_la_!' -i $f
done
sed -e "s!<With_Flavors!<With_Flavors ColocateLibraries=\"no\"!" \
  -i pkgdata/pkg_data_src.gpt.in

%{_mingw32_datadir}/globus/globus-bootstrap.sh

%_mingw32_configure --disable-static --with-flavor=%{flavor} \
		    --with-docdir=%{_mingw32_docdir}/%{name}-%{version}
find . -name Makefile -exec sed 's/^LDFLAGS =/& -no-undefined/' -i {} ';'

make %{?_smp_mflags}

%install
export GLOBUS_LOCATION=%{_mingw32_prefix}

rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT

GLOBUSPACKAGEDIR=$RPM_BUILD_ROOT%{_mingw32_datadir}/globus/packages

# Install license file
mkdir -p $RPM_BUILD_ROOT%{_mingw32_docdir}/%{name}-%{version}
install -m 644 -p GLOBUS_LICENSE \
  $RPM_BUILD_ROOT%{_mingw32_docdir}/%{name}-%{version}

# Generate package filelists
cat $GLOBUSPACKAGEDIR/%{_name}/%{flavor}_rtl.filelist \
    $GLOBUSPACKAGEDIR/%{_name}/%{flavor}_pgm.filelist \
    $GLOBUSPACKAGEDIR/%{_name}/%{flavor}_dev.filelist \
  | sed s!^!%{_mingw32_prefix}! > package.filelist
cat $GLOBUSPACKAGEDIR/%{_name}/noflavor_doc.filelist \
  | sed -e 's!/man/.*!&*!' -e 's!^!%doc %{_mingw32_prefix}!' >> package.filelist

%clean
rm -rf $RPM_BUILD_ROOT

%files -f package.filelist
%defattr(-,root,root,-)
%dir %{_mingw32_datadir}/globus/packages/%{_name}
%{_mingw32_bindir}/libglobus_rls_client-5.dll
%dir %{_mingw32_docdir}/%{name}-%{version}
%doc %{_mingw32_docdir}/%{name}-%{version}/GLOBUS_LICENSE

%changelog
* Mon Feb 06 2012 Mattias Ellert <mattias.ellert@fysast.uu.se> - 5.2-5
- Recompile against Globus Toolkit 5.2.0

* Sat Jul 17 2010 Mattias Ellert <mattias.ellert@fysast.uu.se> - 5.2-4
- Update to Globus Toolkit 5.0.2

* Mon May 03 2010 Mattias Ellert <mattias.ellert@fysast.uu.se> - 5.2-3
- Fix removal of static libraries

* Wed Mar 10 2010 Mattias Ellert <mattias.ellert@fysast.uu.se> - 5.2-2
- Add debug package

* Sun Mar 07 2010 Mattias Ellert <mattias.ellert@fysast.uu.se> - 5.2-1
- Update to Globus Toolkit 5.0.0

* Wed May 06 2009 Mattias Ellert <mattias.ellert@fysast.uu.se> - 5.1-1
- Autogenerated
